﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Serialization;
using KinectReception.Objects;

namespace KinectReception.Managers
{
    public class ConfigurationManager
    {
        public static ObservableCollection<RuleObject> Load()
        {
            var deserializer = new XmlSerializer(typeof(ObservableCollection<RuleObject>));
            try
            {
                var xs = new XmlSerializer(typeof(ObservableCollection<RuleObject>));
                var memoryStream = new MemoryStream(Encoding.UTF8.GetBytes(Properties.Settings.Default.Rules));
                var xmlTextWriter = new XmlTextWriter(memoryStream, Encoding.UTF8);
                return (ObservableCollection<RuleObject>)xs.Deserialize(memoryStream);
            }
            catch (Exception)
            {
                return new ObservableCollection<RuleObject>();
            }
        }

        public static void Save(ObservableCollection<RuleObject> items)
        {
            try
            {
                var memoryStream = new MemoryStream();
                var xs = new XmlSerializer(typeof(ObservableCollection<RuleObject>));

                var xmlTextWriter = new XmlTextWriter(memoryStream, Encoding.UTF8);
                xs.Serialize(xmlTextWriter, items);

                memoryStream = (MemoryStream)xmlTextWriter.BaseStream;
                var xmlizedString = Encoding.UTF8.GetString(memoryStream.ToArray());

                Properties.Settings.Default.Rules = xmlizedString;
            }
            catch (Exception ex)
            {
                throw new ArgumentException(ex.Message);
            }
        }
    }
}
